"""
Do Not Edit this file. You may and are encouraged to look at it for reference.
"""

import unittest
import movable

class TestMovableAbstractMethods( unittest.TestCase ):

    def setUp( self ):
        self.expected_x = 100
        self.expected_y = 200
        self.expected_dx = 1.5
        self.expected_dy = -2.5
        self.expected_world_width = 600
        self.expected_world_height = 400

        self.constructed_movable = movable.Movable( self.expected_x, self.expected_y, self.expected_dx, self.expected_dy, self.expected_world_width, self.expected_world_height )
        
        return

    def tearDown( self ):
        return

    def test001_accelerateIsAbstract( self ):
        delta_velocity = 1.0
        self.assertRaises( NotImplementedError, self.constructed_movable.accelerate, delta_velocity )
        return
    
    def test002_evolveIsAbstract( self ):
        dt = 0.5
        self.assertRaises( NotImplementedError, self.constructed_movable.evolve, dt )
        return
    
    def test003_drawIsAbstract( self ):
        surface = None
        self.assertRaises( NotImplementedError, self.constructed_movable.draw, surface )
        return
    
def suite( ):
    return unittest.TestLoader( ).loadTestsFromTestCase( TestMovableAbstractMethods )

if __name__ == '__main__':
    runner = unittest.TextTestRunner( )
    runner.run( suite( ) )
