"""
Do Not Edit this file. You may and are encouraged to look at it for reference.
"""

import unittest
import math
import asteroids, ship, rock

class TestAsteroidsConstructorAndGetters( unittest.TestCase ):

    def setUp( self ):
        self.expected_rock_count = 10
        self.expected_object_count = 11
        self.expected_world_width = 800
        self.expected_world_height = 600
        self.constructed_obj = asteroids.Asteroids( self.expected_world_width, self.expected_world_height )
        
        return

    def tearDown( self ):
        return
    
    def test001_ConstructorSetsWorldWidth( self ):
        self.assertEqual( self.constructed_obj.getWorldWidth( ), self.expected_world_width )
        return
    
    def test002_ConstructorSetsWorldHeight( self ):
        self.assertEqual( self.constructed_obj.getWorldHeight( ), self.expected_world_height )
        return

    def test003_ConstructorCreatesShip( self ):
        ship_obj = self.constructed_obj.getShip( )
        self.assertEqual( isinstance( ship_obj, ship.Ship ), True )
        return

    def test004_ConstructorCreatesRocks( self ):
        rocks = self.constructed_obj.getRocks( )
        self.assertEqual( len( rocks ), self.expected_rock_count )
        for rock_obj in rocks:
            self.assertEqual( isinstance( rock_obj, rock.Rock ), True )
        return

    def test005_ConstructorCreatesObjects( self ):
        objects = self.constructed_obj.getObjects( )
        self.assertEqual( len( objects ), self.expected_object_count )
        return

   
def suite( ):
    return unittest.TestLoader( ).loadTestsFromTestCase( TestAsteroidsConstructorAndGetters )

if __name__ == '__main__':
    runner = unittest.TextTestRunner( )
    runner.run( suite( ) )
